=== debian/control ===
Source: o-saft
Section: utils
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders: Samuel Henrique <samueloph@debian.org>
Build-Depends: bash-completion,
               debhelper-compat (= 13)
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: https://owasp.org/www-project-o-saft/
Vcs-Browser: https://salsa.debian.org/pkg-security-team/o-saft
Vcs-Git: https://salsa.debian.org/pkg-security-team/o-saft.git

Package: o-saft
Architecture: all
Depends: libio-socket-ssl-perl,
         libnet-dns-perl,
         libnet-ssleay-perl,
         libreadonly-perl,
         openssl,
         perl,
         ${misc:Depends}
Recommends: libperl-critic-perl,
            tk (>= 8.5)
Description: SSL advanced forensic tool
 O-Saft is an easy to use tool to show information about SSL certificates and
 tests the SSL connection according to a given list of ciphers and various SSL
 configurations.
 .
 It's designed to be used by penetration testers, security auditors or server
 administrators. The idea is to show the important information or the special
 checks with a simple call of the tool. However, it provides a wide range of
 options so that it can be used for comprehensive and special checks by
 experienced people.
