=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_fixperms:
	dh_fixperms
	chmod 644 debian/o-saft/usr/share/doc/o-saft/examples/*
	chmod 755 debian/o-saft/usr/share/o-saft/o-saft-img.tcl

override_dh_auto_install:
	dh_auto_install
	dh_bash-completion

override_dh_installexamples:
	dh_installexamples -Xbash_completion
