=== debian/watch ===
version=4
opts="filenamemangle=s/.*\/(.*)\.tar\.gz/o-saft-$1.tar.gz/" \
https://github.com/OWASP/O-Saft/tags .*/(.*)\.tar\.gz
