=== debian/changelog ===
o-saft (22.02.22-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Update standards version to 4.6.0, no changes needed.

  [ Samuel Henrique ]
  * New upstream version 22.02.22
  * Commit all 22.02.22-1 changes at once :(
    - The whole packaging of o-saft had to be refactored as I didn't have
      enough experience to do it right the first time. This is an improved
      version of the packaging with hopefully no regressions.
      I don't have the time to split the changes into different commits or
      changelog entries (and our time is valuable), so here are the big
      changes:
    - Stop installing upstream's contrib files, there's a lot of things
      there and I don't think there's anyone using it.
    - Stop relying on Makefile for packaging, we only need to call the
      install script. This allows me to remove most of the previous
      patches. Two new patches were needed for this, but they will be
      much more simple to maintain.
    - Add a dependency on ca-certificates

 -- Samuel Henrique <samueloph@debian.org>  Thu, 10 Mar 2022 23:42:15 +0000
