=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders: Samuel Henrique <samueloph@debian.org>
 Build-Depends: bash-completion,
                debhelper-compat (= 13)
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://owasp.org/www-project-o-saft/
 Vcs-Browser: https://salsa.debian.org/pkg-security-team/o-saft
@@ -13,7 +13,8 @@
 
 Package: o-saft
 Architecture: all
-Depends: libio-socket-ssl-perl,
+Depends: ca-certificates,
+         libio-socket-ssl-perl,
          libnet-dns-perl,
          libnet-ssleay-perl,
          libreadonly-perl,
